﻿using Syncfusion.Windows.Forms.Grid.Grouping;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.GridHelperClasses;
using System.Drawing.Printing;

namespace CellGrid
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.StartPosition = FormStartPosition.CenterScreen;
            DataCollection data = new DataCollection();
            Random rand = new Random();
            int r = rand.Next(100);
            for (int i = 0; i < 200; i++)
            {
                data.Add(new Data(r.ToString(), "Category" + r.ToString(), "Desc" + r.ToString(), r.ToString() + "Data"));
                r = rand.Next(100);
            }

            gridGroupingControl1.DataSource = data;
            this.gridGroupingControl1.AllowProportionalColumnSizing = true;
            this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false;
            this.gridGroupingControl1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Metro;
        }

        private void print_Click(object sender, EventArgs e)
        {
            GroupingGridPrintDocumentAdv printDocument = new GroupingGridPrintDocumentAdv(this.gridGroupingControl1);
            printDocument.HeaderPrintStyleInfo.Text = "Syncfusion Software Private Ltd";
            printDocument.HeaderPrintStyleInfo.Font.Bold = true;
            printDocument.HeaderPrintStyleInfo.Font.Size = 20;
            printDocument.HeaderPrintStyleInfo.TextColor = Color.Orange;
            printDocument.HeaderPrintStyleInfo.HorizontalAlignment = GridHorizontalAlignment.Center;
            printDocument.HeaderHeight = 30;
            //Event Subscription.
            printDocument.PrintPage += new PrintPageEventHandler(printDocument_PrintPage);
            printDocument.DrawGridPrintHeader += new GridPrintDocumentAdv.DrawGridHeaderFooterEventHandler(printDocument_DrawGridPrintHeader);
            PrintPreviewDialog previewDialog = new PrintPreviewDialog();
            previewDialog.Document = printDocument;
            printDocument.DefaultPageSettings.Landscape = false;
            printDocument.DefaultPageSettings.Margins = new System.Drawing.Printing.Margins(0, 0, 0, 0);
            previewDialog.ShowDialog();
        }

        bool firstPagePrinted = true;
        void printDocument_PrintPage(object sender, PrintPageEventArgs e)
        {
            if (firstPagePrinted)
                e.PageSettings.Margins = new Margins(0, 0, 0, 0);
        }

        void printDocument_DrawGridPrintHeader(object sender, GridPrintHeaderFooterTemplateArgs e)
        {
            if (e.PageNumber == 1)
                firstPagePrinted = true;
            else
            {
                //To avoid Headers in pages other than first page.
                e.Cancel = true;
            }           
        }
    }
}
